=== modified file 'bzrlib/groupcompress.py'
--- bzrlib/groupcompress.py	2009-06-23 21:00:55 +0000
+++ bzrlib/groupcompress.py	2009-06-24 14:38:14 +0000
@@ -1413,6 +1413,7 @@
         # XXX: TODO: remove this, it is just for safety checking for now
         inserted_keys = set()
         for record in stream:
+            # Avoid inserting records that are already present.
             if len(list(self._index._get_entries([record.key]))) > 0:
                 continue
             # Raise an error when a record is missing.

=== modified file 'bzrlib/tests/test_groupcompress.py'
--- bzrlib/tests/test_groupcompress.py	2009-06-10 03:56:49 +0000
+++ bzrlib/tests/test_groupcompress.py	2009-06-24 14:38:14 +0000
@@ -649,6 +649,21 @@
             frozenset([('parent-1',), ('parent-2',)]),
             index.get_missing_parents())
 
+    def test_avoid_redundant_inserts(self):
+        """Should not insert a record that is already present."""
+        source = self.make_test_vf(True, dir='source')
+        source.add_lines(('a',), (), ['lines\n'])
+        target = self.make_test_vf(True, dir='target')
+        _add_records = target._index.add_records
+        added_nodes = []
+        def add_records(nodes, *args, **kwargs):
+            added_nodes.append(nodes)
+            return _add_records(nodes, *args, **kwargs)
+        target._index.add_records = add_records
+        for x in range(2):
+            target.insert_record_stream(source.get_record_stream(
+                [('a',)], 'unordered', False))
+        self.assertEqual(1, len(added_nodes))
 
 class TestLazyGroupCompress(tests.TestCaseWithTransport):
 

